//  Definition of the scoreboard class:

#define SBSIZE 1024

class ScoreBoard {
  public:
	ScoreBoard() {first_=0; length_=0;}
	int IsEmpty () {return (length_ == 0);}
	void ClearScoreBoard () {length_ = 0;}
	int GetNextRetran ();
	void MarkRetran (int retran_seqno, int snd_nxt);
	void ClearRetran (int &retran_data);
	void UpdateScoreBoard (int last_ack_, Packet *pkt, int &retran_data);
	int LastElementOrLastAck(int last_ack);
	
  protected:
        int first_, length_;
        struct ScoreBoardNode {
		int seq_no_;
		int ack_flag_;
		int sack_flag_;
		int retran_;
		int snd_nxt_;
	} SBN[SBSIZE+1];
};

